/// @cond EO_CXX_EO_IMPL

inline ::eo_cxx::elm::sys_notify::dbus::operator ::elm::sys_notify::dbus() const
{
   return *static_cast<::elm::sys_notify::dbus const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::sys_notify::dbus::operator ::elm::sys_notify::dbus&()
{
   return *static_cast<::elm::sys_notify::dbus*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::sys_notify::dbus::operator ::elm::sys_notify::dbus const&() const
{
   return *static_cast<::elm::sys_notify::dbus const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::sys_notify::dbus >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
         , virtual operations< ::elm::sys_notify_interface >::template type<T>
   {
   };
};


template<>
struct operation_description_class_size< ::elm::sys_notify::dbus >
{
   static constexpr int value = 
#if defined(DBUS_PROTECTED) && defined(DBUS_BETA)
      0
#elif defined(DBUS_PROTECTED)
      0
#elif defined(DBUS_BETA)
      0
#else
      0
#endif
      + operation_description_class_size<::eo::base >::value      + operation_description_class_size<::elm::sys_notify_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::sys_notify::dbus>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[operation_description_class_size< ::elm::sys_notify::dbus >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::sys_notify_interface>(), &ops[operation_description_class_size< ::elm::sys_notify::dbus >::value + operation_description_class_size<::eo::base>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::sys_notify::dbus>)
{
   return (ELM_SYS_NOTIFY_DBUS_CLASS);
}

} } }

/// @endcond

